# SoJackDragger Class Reference
[Draggers]

`#include <Inventor/draggers/SoJackDragger.h>`

Inheritance diagram for SoJackDragger:

List of all members.

## Detailed Description

The SoJackDragger class is a dragger you can translate, rotate and scale.

Here's how the dragger looks with it's default geometry in the inactive state:

Translation is done with this dragger by picking the flat transparent box ("x-z" translation) or the solid middle part of the axis ("y"-axis translation). Press a SHIFT-key while translating in x-z to constrain to one of the principal axes.

Uniform scale operations can be done by dragging any of the 6 cubes. Non-uniform scale operations can not be done with this dragger.

Rotations are invoked by clicking and dragging the line parts of the 3 principal "axes" of the dragger geometry.

An "action shot" of the SoJackDragger used within an SoClipPlaneManip:

The name "Jack dragger" probably stems from this dragger being implemented by SGI for interacting with a "jack-in-the-box" type model way back in the Inventor history.

For programmer convenience, this dragger comes fully wrapped within instances of the SoJackManip class. The SoClipPlaneManip manipulator also uses this dragger, for controlling an SoClipPlane node.

## Public Member Functions

| SoJackDragger (void)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFRotation | rotation
SoSFVec3f | translation
SoSFVec3f | scaleFactor

## Protected Member Functions

| ~SoJackDragger ()
virtual SbBool | setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
virtual void | setDefaultOnNonWritingFields (void)

## Static Protected Member Functions

void | invalidateSurroundScaleCB (void *f, SoDragger *d)
void | fieldSensorCB (void *f, SoSensor *s)
void | valueChangedCB (void *f, SoDragger *d)

## Protected Attributes

SoFieldSensor * | rotFieldSensor
SoFieldSensor * | translFieldSensor
SoFieldSensor * | scaleFieldSensor

## Constructor & Destructor Documentation

SoJackDragger::SoJackDragger | ( | void |  | ) |

Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry.

Node kit structure (new entries versus parent class marked with arrow prefix):

      CLASS SoJackDragger
      -->"this"
            "callbackList"
            "topSeparator"
               "motionMatrix"
      -->      "surroundScale"
      -->      "antiSquish"
      -->      "scaler"
      -->      "rotator"
      -->      "translator"
               "geomSeparator"

(See SoBaseKit::printDiagram() for information about the output formatting.)

Detailed information on catalog parts:

      CLASS SoJackDragger
      PVT   "this",  SoJackDragger  ---
            "callbackList",  SoNodeKitListPart [ SoCallback, SoEventCallback ]
      PVT   "topSeparator",  SoSeparator  ---
      PVT   "motionMatrix",  SoMatrixTransform  ---
            "surroundScale",  SoSurroundScale  ---
            "antiSquish",  SoAntiSquish  ---
            "scaler",  SoScaleUniformDragger  ---
            "rotator",  SoRotateSphericalDragger  ---
            "translator",  SoDragPointDragger  ---
      PVT   "geomSeparator",  SoSeparator  ---

(See SoBaseKit::printTable() for information about the output formatting.)

SoJackDragger::~SoJackDragger | ( |  | ) | `[protected]`

| Protected destructor. (Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

## Member Function Documentation

void SoJackDragger::initClass | ( | void |  | ) | `[static]`

| Initializes type system for this dragger class. Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init(). Reimplemented from SoDragger.

SbBool SoJackDragger::setUpConnections | ( | SbBool | onoff,
|  | SbBool | doitalways = FALSE
| ) | `[protected, virtual]`

| Sets up all internal connections for instances of this class. (This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.) Reimplemented from SoInteractionKit.

void SoJackDragger::setDefaultOnNonWritingFields | ( | void |  | ) | `[protected, virtual]`

(Be aware that this method is unlikely to be of interest to the application programmer who does not want to extend the library with new custom nodekits or draggers. If you indeed are writing extensions, see the information in the SoBaseKit class documentation.)

This is a virtual method, and the code in it should call SoField::setDefault() with argument `TRUE` on part fields that should not be written upon scenegraph export operations.

This is typically done when:

1. field value is `NULL` and part is `NULL` by default

2. it is a leaf SoGroup or SoSeparator node with no children

3. it is a leaf listpart with no children and an SoGroup or SoSeparator container

4. it is a non-leaf part and it's of SoGroup type and all fields are at their default values

Subclasses should usually override this to do additional settings for new member fields. From the subclass, do remember to call "upwards" to your superclass' setDefaultOnNonWritingFields() method.

Reimplemented from SoDragger.

void SoJackDragger::invalidateSurroundScaleCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| Used to invalidate the surroundScale and antiSquish parts when a child dragger starts or finishes dragging.

void SoJackDragger::fieldSensorCB | ( | void * | d,
|  | SoSensor * | s
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Reimplemented from SoInteractionKit.

void SoJackDragger::valueChangedCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## Member Data Documentation

SoSFRotation SoJackDragger::rotation

| This field is continuously updated to contain the rotation of the current direction vector of the dragger.

SoSFVec3f SoJackDragger::translation

| Continuously updated to contain the current translation from the dragger's local origo position. The application programmer applying this dragger in his code should connect the relevant node fields in the scene to this field to make it follow the dragger.

SoSFVec3f SoJackDragger::scaleFactor

| Continuously updated to contain the current vector of scaling along the X, Y and Z axes. Only uniform scaling can be done with the SoJackDragger, so the 3 vector components will always be equal.

SoFieldSensor * SoJackDragger::rotFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoJackDragger::translFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoJackDragger::scaleFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoJackDragger.h
- SoJackDragger.cpp